# Author: Xavier Outhier, vice-president of a non-profit association
# D2SET: Diffusion and Developpement of Scientific and tEchnic poTential
#
# To contact us:
#  web site: http://www.multimania.com/d2set/
#  e-mail: d2set@multimania.com

# Condition of use: feel free to use it as you like but always let
# these comments. If it is usefull for you, great. Send us message
# for any feedback. You can find the script and other on our web site.

# Originak goal: concat several HTML file in one huge to be used later
# by html2ps in order to have one PostScript file containing printable
# file made by Javadoc. 
# In the concatened file each original file will be separated with
# <!-- NewPage --> in order to make the content of each indivual
# HTML file appear at the top of a new page in the postscript version.


import sys
import glob

#
# Usage of the script
#
usage = """Usage: 'python javadoc1.py hugeFile [filesToConcatenate]'
a file hugeFile will contain all filesToConcatenate and
between each there will be <!-- NewPage -->.
You can use wild card :
 * matches everything
 ? matches any single character
 [seq] matches any character in seq
 [!seq] matches any character _not_ in seq.

Example #1:
 python javadoc1.py BIG.html *.html
 will concatenate all html file of the current directory

Example #2:
 python javadoc1.py BIG.html dir1/file[0-2].html f[!0-2].html
 will concatenate all html file that could be dir1/file0.html,
 dir1/file1.html or dir1/file2.html and then all of html files
 in the current directory but f0.html, f1.html and f2.html.

Note #1: You can use indefferently / or \ as directory separator.
Note #2: hugeFile will not be included in itself.
Note #3: You should have Python installed (tested with version 1.5)
"""

#
# Goodbye message
#
goodbye ="""\nYou liked this script, find it and other things
at our  web site: http://www.multimania.com/d2set/
or send us an email: d2set@multimania.com"""

#
# Check the size of the command line
#
if (len(sys.argv[1:]) < 2):
    print usage
    sys.exit()
else:
    #
    # We open the file in which we will concatenate the others
	# Warning: If it is already existing it will be erased.
    #
    hugeFileName = sys.argv[1]
    hugeFile = open (hugeFileName, "w")
    for arg in sys.argv[2:]:
        #
        # To be able to use wild card
    	#
        for fileName in glob.glob(arg):
            #
            # Check to avoid including the hugeFile itself
    	    #
            if (fileName != hugeFileName):
			    #
				# We open the file to be concatened
				#
                fileInput = open(fileName,"r") 
                if (fileInput):
		            #
                    # We concatenate adding the HTML comment
    	            #
                    hugeFile.write('\n<!--NewPage-->\n')
                    for line in fileInput.readlines():
                        hugeFile.write(line)
    			    #
	    			# We close the file concatened
		    		#
                    fileInput.close()
                    print fileName+" has been added to "+hugeFileName
                else: print fileInput+" does'nt exit, it is skiped"
    #
    # We close the file in which we have concatenated the others.
    #
    hugeFile.close ()
    print goodbye
